import java.awt.*;
import javax.swing.*;
public class Engine2008 extends JPanel implements Runnable{
    Thread t;
    ImageFrameEngine2008 imf;
    Image img;
    Graphics h;
    Polygon start;
    Polygon end;
    PaintGroup pgstart;
    PaintGroup pgend;
    String status="astrosolutions.de";
    private static final long serialVersionUID = -5570001361703818151L;
    public Engine2008(){
        imf=new ImageFrameEngine2008();
        img=imf.img;
        h=img.getGraphics();
        t=new Thread(this);
        t.start();
    }
    public void run(){
        boolean running=true;
        try{
            while(running){
                Thread.sleep(100);
                repaint();
            }
        }
        catch(Exception e){
        }
    }
    public synchronized void setNotProcessed(){
        Polygon cur=start;
        while(cur!=null){
            if(cur.pg!=null){
                cur.pg.setNotProcessed();
            }
            cur=cur.next;
        }
    }
    public synchronized void remove(Polygon poly){
        Polygon fore=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur==poly){
                if(cur.pg!=null){
                    cur.pg.remove(cur);
                }
                if(fore==null){
                    start=cur.next;
                }
                if(cur.next==null){
                    end=fore;
                }
                if(fore!=null){
                    fore.next=cur.next;
                }
            }
            fore=cur;
            cur=cur.next;
        }
    }
    public synchronized void remove(Group g){
        Polygon cur=g.start;
        while(cur!=null){
            remove(cur);
            cur=cur.grnext;
        }
    }
    public synchronized void rotUp(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.next;
        }
    }
    public synchronized void rotLeft(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.next;
        }
    }
    public synchronized void transform(double a,double b,double c){
        Polygon cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.next;
        }
    }
    public synchronized void getPaintGroups(){
        pgstart=null;
        pgend=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur.pg==null){
                cur.pg=new PaintGroup();
                cur.pg.add(cur);
                cur.pg.setProcessed();
                addPaintGroup(cur.pg);
            }
            else{
                if(!cur.pg.processed){
                    addPaintGroup(cur.pg);
                    cur.pg.setProcessed();
                }
            }
            cur=cur.next;
        }
    }
    public synchronized void addPaintGroup(PaintGroup pg){
        if(pgstart==null){
            pgstart=pg;
            pgend=pg;
        }
        else{
            pgend.next=pg;
            pgend=pgend.next;
        }
    }
    public synchronized void add(Polygon p){
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.next=p;
            end=end.next;
        }
    }
    public synchronized void add(Group group){
        Polygon cur=group.start;
        while(cur!=null){
            add(cur);
            cur=cur.grnext;
        }
    }
    public static void sort(PaintGroup[]a,int l,int r){
//Quicksort sortiert PaintGroups nach entf-Werten
        if(l>=r){
            return;
        }
        PaintGroup[]part=new PaintGroup[r-l+1];
        PaintGroup[]partm=new PaintGroup[r-l+1];
        int middle=(l+r)/2;
        double middlevalue=a[middle].entf;
        int i=0;
        int j=r-l;
        int m=0;
        for(int k=l;k<=r;k++){
            if(a[k].entf<middlevalue){
                part[i]=a[k];
                i++;
            }
            else if(a[k].entf>middlevalue){
                part[j]=a[k];
                j--;
            }
            else{
                partm[m]=a[k];
                m++;
            }
        }
        for(int k=0;k<i;k++){
            a[k+l]=part[k];
        }
        for(int k=0;k<m;k++){
            a[i+k+l]=partm[k];
        }
        for(int k=r-l;k>j;k--){
            a[k+l]=part[k];
        }
        sort(a,l,i-1+l);
        sort(a,j+1+l,r);
    }
    public Vektor getCoord(Vektor v){
        double x=v.x;
        double y=v.y;
        double z=v.z;
        double vx=Math.atan(y/x)/(Math.PI/6)*200;
        double vy=Math.atan(z/x)/(Math.PI/6)*200;
        double vz=x;
        Vektor rvv=new Vektor(vx,vy,vz);
        return rvv;
    }
//    public synchronized void paint(Graphics g){
//    }
    public synchronized void paint(Graphics g){
        h.setColor(Color.white);
        h.fillRect(0,0,800,600);
        setNotProcessed();
        getPaintGroups();
        PaintGroup pgcur=pgstart;
        int count=0;
        while(pgcur!=null){
            pgcur.getEntf();
            pgcur=pgcur.next;
            count++;
        }
        pgcur=pgstart;
        PaintGroup[]pgs=new PaintGroup[count];
        for(int i=0;i<count;i++){
            pgs[i]=pgcur;
            pgcur=pgcur.next;
        }
        sort(pgs,0,pgs.length-1);
        for(int i=pgs.length-1;i>=0;i--){
            Polygon pol=pgs[i].start;
            while(pol!=null){
                Vektor point=pol.start;
                if(pol.kugel){
                    Vektor kv=getCoord(point);
                    if(kv.z>0){
                        double winkel=Math.atan(pol.radius/pgs[i].entf);
                        int len=(int)((winkel/(Math.PI/6))*200);
                        h.setColor(pol.col);
                        h.fillOval(200-(len/2)+((int)kv.x),200-(len/2)+((int)kv.y),len,len);
                    }
                }
                else{
                    java.awt.Polygon pogy=new java.awt.Polygon();
                    boolean seen=true;
                    while(point!=null){
                        Vektor veci=getCoord(point);
                        if(veci.z<=0){
                            seen=false;
                        }
                        pogy.addPoint((int)(200+veci.x),(int)(200+veci.y));
                        point=point.next;
                    }
                    if(seen){
                        h.setColor(pol.col);
                        h.fillPolygon(pogy);
                    }
                }
                pol=pol.gnext;
            }
        }
        h.setColor(Color.black);
        h.drawString(status,10,90);
        g.drawImage(img,0,0,this);
//        paint(g);
    }
    public void setStatus(String status){
        this.status=status;
    }
}
class PaintGroup{
    PaintGroup next;
    Polygon start;
    Polygon end;
    boolean processed=false;
    double entf=0;
    public PaintGroup(){
    }
    public void getEntf(){
        entf=entf();
    }
    public void setProcessed(){
        processed=true;
    }
    public void setNotProcessed(){
        processed=false;
    }
    public void reset(){
        start=null;
        end=null;
    }
    public void remove(Polygon poly){
        Polygon fore=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur==poly){
                if(fore==null){
                    start=cur.gnext;
                }
                if(cur.gnext==null){
                    end=fore;
                }
                if(fore!=null){
                    fore.gnext=cur.gnext;
                }
            }
            fore=cur;
            cur=cur.gnext;
        }
    }
    public void add(Polygon p){
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.gnext=p;
            end=end.gnext;
        }
    }
    public double entf(){
        int count=0;
        Polygon cur=start;
        Vektor sum=new Vektor(0,0,0);
        while(cur!=null){
            Vektor cur2=cur.start;
            while(cur2!=null){
                sum.transform(cur2.getX(),cur2.getY(),cur2.getZ());
                cur2=cur2.next;
                count++;
            }
            cur=cur.gnext;
        }
        Vektor ret=new Vektor(sum.x/count,sum.y/count,sum.z/count);
        return ret.entf();
    }
}
class Group{
    Polygon start;
    Polygon end;
    public Group cloneo(){
        Group group=new Group();
        Polygon cur=start;
        while(cur!=null){
            group.add(cur.cloneo());
            cur=cur.grnext;
        }
        return group;
    }
    public void add(Polygon p){
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.grnext=p;
            end=end.grnext;
        }
    }
    public void rotUp(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.grnext;
        }
    }
    public void rotLeft(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.grnext;
        }
    }
    public void transform(double a,double b,double c){
        Polygon cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.grnext;
        }
    }
}
class Kugel extends Polygon{
    public Kugel(Color col,Vektor v,double radius){
        super(col);
        add(v);
        this.radius=radius;
        this.kugel=true;
    }
    public Vektor getCenter(){
        return start;
    }
}
class Quad extends Polygon{
    public Quad(Color col,Vektor v1,Vektor v2,Vektor v3,Vektor v4){
        super(col);
        add(v1);
        add(v2);
        add(v3);
        add(v4);
    }
    public Vektor getV1(){
        return start;
    }
    public Vektor getV2(){
        return start.next;
    }
    public Vektor getV3(){
        return start.next.next;
    }
    public Vektor getV4(){
        return start.next.next.next;
    }
}
class Triangle extends Polygon{
    public Triangle(Color col,Vektor v1,Vektor v2,Vektor v3){
        super(col);
        add(v1);
        add(v2);
        add(v3);
    }
    public Vektor getV1(){
        return start;
    }
    public Vektor getV2(){
        return start.next;
    }
    public Vektor getV3(){
        return start.next.next;
    }
}
class Polygon{
    Polygon next;
    Polygon gnext;
    Polygon grnext;
    PaintGroup pg;
    Vektor start;
    Vektor end;
    Color col;
    boolean kugel=false;
    double radius=0;
    boolean processed=false;
    double entf=0;
    public Polygon(Color col){
        this.col=col;
    }
    public Polygon cloneo(){
        Polygon ret=new Polygon(col);
        ret.kugel=kugel;
        ret.radius=radius;
        ret.processed=processed;
        ret.entf=entf;
        Vektor cur=start;
        while(cur!=null){
            ret.add(cur.cloneo());
            cur=cur.next;
        }
        return ret;
    }
    public void setProcessed(){
        processed=true;
    }
    public void setNotProcessed(){
        processed=false;
    }
    public void setPaintGroup(PaintGroup pg){
        this.pg=pg;
        pg.add(this);
    }
    public void add(Vektor v){
        if(start==null){
            start=v;
            end=v;
        }
        else{
            end.next=v;
            end=end.next;
        }
    }
    public void rotUp(double w){
        Vektor cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.next;
        }
    }
    public void rotLeft(double w){
        Vektor cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.next;
        }
    }
    public double entf(){
        int count=0;
        Vektor cur=start;
        Vektor sum=new Vektor(0,0,0);
        while(cur!=null){
            sum.transform(cur.getX(),cur.getY(),cur.getZ());
            cur=cur.next;
            count++;
        }
        Vektor ret=new Vektor(sum.x/count,sum.y/count,sum.z/count);
        return ret.entf();
    }
    public void transform(double a,double b,double c){
        Vektor cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.next;
        }
    }
}
class ImageFrameEngine2008 extends JFrame{
    Image img;
    private static final long serialVersionUID = 8018112712134813132L;
    public ImageFrameEngine2008(){
        pack();
        img=createImage(800,600);
    }
}
class Vektor{
    double x,y,z;
    double xtra;
    Vektor next;
    public Vektor(double x,double y,double z){
        this.x=x;
        this.y=y;
        this.z=z;
    }
    public void print(){
        System.out.println("x: "+x+" y: "+y+" z: "+z);
    }
    public double getX(){
        return x;
    }
    public double getY(){
        return y;
    }
    public double getZ(){
        return z;
    }
    public double getXtra(){
        return xtra;
    }
    public Vektor cloneo(){
        Vektor cl=new Vektor(x,y,z);
        cl.xtra=xtra;
        return cl;
    }
    public void transform(double a,double b,double c){
        x+=a;
        y+=b;
        z+=c;
    }
    public void setCoord(int coord,double a){
        if(coord==1)x=a;
        else if(coord==2)y=a;
        else if(coord==2)z=a;
    }
    public void changeCoord(int coord1,int coord2){
        double temp=0;
        if((coord1==1&&coord2==2)||(coord1==2&&coord2==1)){
            temp=x;
            x=y;
            y=temp;
        }
        if((coord1==1&&coord2==3)||(coord1==3&&coord2==1)){
            temp=x;
            x=z;
            z=temp;
        }
        if((coord1==2&&coord2==3)||(coord1==3&&coord2==1)){
            temp=y;
            y=z;
            z=temp;
        }
    }
    public double entf(){
        return Math.sqrt(x*x+y*y+z*z);
    }
    public void rotLeft(double w){
        double win=0;
        if(x==0){
            if(y>0)win=Math.PI/2;
            else win=-Math.PI/2;
        }
        else{
            win=Math.atan(y/x);
        }
        if(x<0)win+=Math.PI;
        double len=Math.sqrt(x*x+y*y);
        win+=w;
        x=Math.cos(win)*len;
        y=Math.sin(win)*len;
    }
    public void rotUp(double w){
        double win=0;
        if(x==0){
            if(z>0)win=Math.PI/2;
            else win=-Math.PI/2;
        }
        else{
            win=Math.atan(z/x);
        }
        if(x<0)win+=Math.PI;
        double len=Math.sqrt(x*x+z*z);
        win+=w;
        x=Math.cos(win)*len;
        z=Math.sin(win)*len;
    }
}
